--- old/testsuite/devices.test
+++ new/testsuite/devices.test
@@ -42,14 +42,14 @@ touch -r "$fromdir/block" "$fromdir/bloc
 $RSYNC -ai "$fromdir/block" "$todir/block2" \
     | tee "$outfile"
 cat <<EOT >"$chkfile"
-cD+++++++ block
+cD+++++++++ block
 EOT
 diff $diffopt "$chkfile" "$outfile" || test_fail "test 1 failed"
 
 $RSYNC -ai "$fromdir/block2" "$todir/block" \
     | tee "$outfile"
 cat <<EOT >"$chkfile"
-cD+++++++ block2
+cD+++++++++ block2
 EOT
 diff $diffopt "$chkfile" "$outfile" || test_fail "test 2 failed"
 
@@ -58,7 +58,7 @@ sleep 1
 $RSYNC -Di "$fromdir/block3" "$todir/block" \
     | tee "$outfile"
 cat <<EOT >"$chkfile"
-cD..T.... block3
+cD..T...... block3
 EOT
 diff $diffopt "$chkfile" "$outfile" || test_fail "test 3 failed"
 
@@ -66,15 +66,15 @@ $RSYNC -aiHvv "$fromdir/" "$todir/" \
     | tee "$outfile"
 filter_outfile
 cat <<EOT >"$chkfile"
-.d..t.... ./
-cD..t.... block
-cD        block2
-cD+++++++ block3
-hD+++++++ block2.5 => block3
-cD+++++++ char
-cD+++++++ char2
-cD+++++++ char3
-cS+++++++ fifo
+.d..t...... ./
+cD..t...... block
+cD          block2
+cD+++++++++ block3
+hD+++++++++ block2.5 => block3
+cD+++++++++ char
+cD+++++++++ char2
+cD+++++++++ char3
+cS+++++++++ fifo
 EOT
 if test ! -b "$fromdir/block2.5"; then
     sed -e '/block2\.5/d' \
@@ -94,15 +94,15 @@ if test -b "$fromdir/block2.5"; then
     $RSYNC -aii --link-dest="$todir" "$fromdir/" "$chkdir/" \
 	| tee "$outfile"
     cat <<EOT >"$chkfile"
-cd        ./
-hD        block
-hD        block2
-hD        block2.5
-hD        block3
-hD        char
-hD        char2
-hD        char3
-hS        fifo
+cd          ./
+hD          block
+hD          block2
+hD          block2.5
+hD          block3
+hD          char
+hD          char2
+hD          char3
+hS          fifo
 EOT
     diff $diffopt "$chkfile" "$outfile" || test_fail "test 4 failed"
 fi
--- old/testsuite/itemize.test
+++ new/testsuite/itemize.test
@@ -47,16 +47,16 @@ rm -f "$to2dir" "$to2dir.test"
 $RSYNC -iplr "$fromdir/" "$todir/" \
     | tee "$outfile"
 sed -e "$sed_cmd" <<EOT >"$chkfile"
-cd+++++++ ./
-cd+++++++ bar/
-cd+++++++ foo/_P30_
-cd+++++++ bar/baz/
->f+++++++ bar/baz/rsync
-cd+++++++ foo/_P29_
->f+++++++ foo/config1
->f+++++++ foo/config2
->f+++++++ foo/extra
-cL+++++++ foo/sym -> ../bar/baz/rsync
+cd+++++++++ ./
+cd+++++++++ bar/
+cd+++++++++ foo/_P30_
+cd+++++++++ bar/baz/
+>f+++++++++ bar/baz/rsync
+cd+++++++++ foo/_P29_
+>f+++++++++ foo/config1
+>f+++++++++ foo/config2
+>f+++++++++ foo/extra
+cL+++++++++ foo/sym -> ../bar/baz/rsync
 EOT
 diff $diffopt "$chkfile" "$outfile" || test_fail "test 1 failed"
 
@@ -68,10 +68,10 @@ chmod 601 "$fromdir/foo/config2"
 $RSYNC -iplrH "$fromdir/" "$todir/" \
     | tee "$outfile"
 sed -e "$sed_cmd" <<EOT >"$chkfile"
->f..T.... bar/baz/rsync
->f..T.... foo/config1
->f.sTp... foo/config2
-hf..T.... foo/extra => foo/config1
+>f..T...... bar/baz/rsync
+>f..T...... foo/config1
+>f.sTp..... foo/config2
+hf..T...... foo/extra => foo/config1
 EOT
 diff $diffopt "$chkfile" "$outfile" || test_fail "test 2 failed"
 
@@ -88,12 +88,12 @@ chmod 777 "$todir/bar/baz/rsync"
 $RSYNC -iplrtc "$fromdir/" "$todir/" \
     | tee "$outfile"
 sed -e "$sed_cmd" <<EOT >"$chkfile"
-.d..t.... foo/_P30_
-.f..tp... bar/baz/rsync
-.d..t.... foo/_P29_
-.f..t.... foo/config1
->fcstp... foo/config2
-cL..T.... foo/sym -> ../bar/baz/rsync
+.d..t...... foo/_P30_
+.f..tp..... bar/baz/rsync
+.d..t...... foo/_P29_
+.f..t...... foo/config1
+>fcstp..... foo/config2
+cL..T...... foo/sym -> ../bar/baz/rsync
 EOT
 diff $diffopt "$chkfile" "$outfile" || test_fail "test 3 failed"
 
@@ -118,15 +118,15 @@ $RSYNC -ivvplrtH "$fromdir/" "$todir/" \
     | tee "$outfile"
 filter_outfile
 sed -e "$sed_cmd" <<EOT >"$chkfile"
-.d        ./
-.d        bar/
-.d        bar/baz/
-.f...p... bar/baz/rsync
-.d        foo/
-.f        foo/config1
->f..t.... foo/config2
-hf        foo/extra
-.L        foo/sym -> ../bar/baz/rsync
+.d          ./
+.d          bar/
+.d          bar/baz/
+.f...p..... bar/baz/rsync
+.d          foo/
+.f          foo/config1
+>f..t...... foo/config2
+hf          foo/extra
+.L          foo/sym -> ../bar/baz/rsync
 EOT
 diff $diffopt "$chkfile" "$outfile" || test_fail "test 5 failed"
 
@@ -145,8 +145,8 @@ touch "$todir/foo/config2"
 $RSYNC -iplrtH "$fromdir/" "$todir/" \
     | tee "$outfile"
 sed -e "$sed_cmd" <<EOT >"$chkfile"
-.f...p... foo/config1
->f..t.... foo/config2
+.f...p..... foo/config1
+>f..t...... foo/config2
 EOT
 diff $diffopt "$chkfile" "$outfile" || test_fail "test 7 failed"
 
@@ -154,15 +154,15 @@ $RSYNC -ivvplrtH --copy-dest=../to "$fro
     | tee "$outfile"
 filter_outfile
 sed -e "$sed_cmd" <<EOT >"$chkfile"
-cd        ./
-cd        bar/
-cd        bar/baz/
-cf        bar/baz/rsync
-cd        foo/
-cf        foo/config1
-cf        foo/config2
-hf        foo/extra => foo/config1
-cL        foo/sym -> ../bar/baz/rsync
+cd          ./
+cd          bar/
+cd          bar/baz/
+cf          bar/baz/rsync
+cd          foo/
+cf          foo/config1
+cf          foo/config2
+hf          foo/extra => foo/config1
+cL          foo/sym -> ../bar/baz/rsync
 EOT
 diff $diffopt "$chkfile" "$outfile" || test_fail "test 8 failed"
 
@@ -170,7 +170,7 @@ rm -rf "$to2dir"
 $RSYNC -iplrtH --copy-dest=../to "$fromdir/" "$to2dir/" \
     | tee "$outfile"
 sed -e "$sed_cmd" <<EOT >"$chkfile"
-hf        foo/extra => foo/config1
+hf          foo/extra => foo/config1
 EOT
 diff $diffopt "$chkfile" "$outfile" || test_fail "test 9 failed"
 
@@ -196,15 +196,15 @@ $RSYNC -ivvplrtH --link-dest="$todir" "$
     | tee "$outfile"
 filter_outfile
 sed -e "$sed_cmd" <<EOT >"$chkfile"
-cd        ./
-cd        bar/
-cd        bar/baz/
-hf        bar/baz/rsync
-cd        foo/
-hf        foo/config1
-hf        foo/config2
-hf        foo/extra => foo/config1
-$L        foo/sym -> ../bar/baz/rsync
+cd          ./
+cd          bar/
+cd          bar/baz/
+hf          bar/baz/rsync
+cd          foo/
+hf          foo/config1
+hf          foo/config2
+hf          foo/extra => foo/config1
+$L          foo/sym -> ../bar/baz/rsync
 EOT
 diff $diffopt "$chkfile" "$outfile" || test_fail "test 11 failed"
 
@@ -244,15 +244,15 @@ $RSYNC -ivvplrtH --compare-dest="$todir"
     | tee "$outfile"
 filter_outfile
 sed -e "$sed_cmd" <<EOT >"$chkfile"
-cd        ./
-cd        bar/
-cd        bar/baz/
-.f        bar/baz/rsync
-cd        foo/
-.f        foo/config1
-.f        foo/config2
-.f        foo/extra
-.L        foo/sym -> ../bar/baz/rsync
+cd          ./
+cd          bar/
+cd          bar/baz/
+.f          bar/baz/rsync
+cd          foo/
+.f          foo/config1
+.f          foo/config2
+.f          foo/extra
+.L          foo/sym -> ../bar/baz/rsync
 EOT
 diff $diffopt "$chkfile" "$outfile" || test_fail "test 15 failed"
 
--- old/uidlist.c
+++ new/uidlist.c
@@ -36,6 +36,7 @@ extern int verbose;
 extern int am_root;
 extern int preserve_uid;
 extern int preserve_gid;
+extern int preserve_acls;
 extern int numeric_ids;
 
 struct idlist {
@@ -272,7 +273,7 @@ void send_uid_list(int f)
 {
 	struct idlist *list;
 
-	if (preserve_uid) {
+	if (preserve_uid || preserve_acls) {
 		int len;
 		/* we send sequences of uid/byte-length/name */
 		for (list = uidlist; list; list = list->next) {
@@ -289,7 +290,7 @@ void send_uid_list(int f)
 		write_int(f, 0);
 	}
 
-	if (preserve_gid) {
+	if (preserve_gid || preserve_acls) {
 		int len;
 		for (list = gidlist; list; list = list->next) {
 			if (!list->name)
@@ -329,18 +330,28 @@ void recv_uid_list(int f, struct file_li
 {
 	int id, i;
 
-	if (preserve_uid && !numeric_ids) {
+	if ((preserve_uid || preserve_acls) && !numeric_ids) {
 		/* read the uid list */
 		while ((id = read_int(f)) != 0)
 			recv_user_name(f, (uid_t)id);
 	}
 
-	if (preserve_gid && !numeric_ids) {
+	if ((preserve_gid || preserve_acls) && !numeric_ids) {
 		/* read the gid list */
 		while ((id = read_int(f)) != 0)
 			recv_group_name(f, (gid_t)id);
 	}
 
+#ifdef SUPPORT_ACLS
+	if (preserve_acls && !numeric_ids) {
+		id_t *id;
+		while ((id = next_acl_uid(flist)) != NULL)
+			*id = match_uid(*id);
+		while ((id = next_acl_gid(flist)) != NULL)
+			*id = match_gid(*id);
+	}
+#endif
+
 	/* Now convert all the uids/gids from sender values to our values. */
 	if (am_root && preserve_uid && !numeric_ids) {
 		for (i = 0; i < flist->count; i++)
--- old/util.c
+++ new/util.c
@@ -1467,3 +1467,31 @@ int bitbag_next_bit(struct bitbag *bb, i
 
 	return -1;
 }
+
+void *expand_item_list(item_list *lp, size_t item_size,
+		       const char *desc, int incr)
+{
+	/* First time through, 0 <= 0, so list is expanded. */
+	if (lp->malloced <= lp->count) {
+		void *new_ptr;
+		size_t new_size = lp->malloced;
+		if (incr < 0)
+			new_size -= incr; /* increase slowly */
+		else if (new_size < (size_t)incr)
+			new_size += incr;
+		else
+			new_size *= 2;
+		new_ptr = realloc_array(lp->items, char, new_size * item_size);
+		if (verbose >= 4) {
+			rprintf(FINFO, "[%s] expand %s to %.0f bytes, did%s move\n",
+				who_am_i(), desc, (double)new_size * item_size,
+				new_ptr == lp->items ? " not" : "");
+		}
+		if (!new_ptr)
+			out_of_memory("expand_item_list");
+
+		lp->items = new_ptr;
+		lp->malloced = new_size;
+	}
+	return (char*)lp->items + (lp->count++ * item_size);
+}
